#include once "fgdk0064.bi"
'compile with -s gui

setdisplaymode(320,200,32)

hidemouse
text(0,0,"Loading...")
sync

loadimage("data\bldg.bmp",1)
loadimage("data\bg.bmp",2)
loadimage("data\d1.bmp",3)
loadimage("data\d2.bmp",4)
loadimage("data\title.bmp",5)

dim shared as integer frame,images(255,4,2),image_r(255,2),direction=2
dim shared as single framecounter,playerx=152,playery=176,people(255,4)
dim shared as ubyte raped(255),pcount,i,spaceup=0
dim shared as string phrases(255)

sub moveperson(byval p as uinteger)
    static as integer f
    if people(p,3)=0 then
        people(p,1)+=frim*40
        people(p,0)+=frim*4
        if people(p,0)>=1 then people(p,0)=people(p,0)-int(people(p,0))
        if people(p,0)<0.5 then
            f=1
        else
            f=0
        end if
    elseif people(p,3)=1 then
        people(p,1)-=frim*40
        people(p,0)+=frim*4
        if people(p,0)>=1 then people(p,0)=people(p,0)-int(people(p,0))
        if people(p,0)<0.5 then
            f=1
        else
            f=0
        end if
    elseif people(p,3)=2 then
        people(p,2)-=frim*40
        people(p,0)+=frim*4
        if people(p,0)>=1 then people(p,0)=people(p,0)-int(people(p,0))
        if people(p,0)<0.5 then
            f=1
        else
            f=0
        end if
    elseif people(p,3)=3 then
        people(p,2)+=frim*40
        people(p,0)+=frim*4
        if people(p,0)>=1 then people(p,0)=people(p,0)-int(people(p,0))
        if people(p,0)<0.5 then
            f=1
        else
            f=0
        end if
    else
        f=0
        people(p,0)=0
    end if
    if people(p,2)<84 then
        people(p,2)=84
        if rnd()<0.5 then
            people(p,3)=1
        else
            people(p,3)=0
        end if
    end if
    if people(p,2)>109 then
        people(p,2)=109
        if rnd()<0.5 then
            people(p,3)=1
        else
            people(p,3)=0
        end if
    end if
    if people(p,1)<0 then
        people(p,1)=0
        if rnd()<0.5 then
            people(p,3)=2
        else
            people(p,3)=3
        end if
    end if
    if people(p,1)>304 then
        people(p,1)=304
        if rnd()<0.5 then
            people(p,3)=2
        else
            people(p,3)=3
        end if
    end if
    pasteimage(images(p,people(p,3),f),people(p,1),people(p,2),1)
end sub

sub makeperson(byval n as string,byval p as uinteger,byval si as uinteger)
    loadbitmap("data\" & n & ".bmp")
    
    getimage(si,0,0,15,23)
    getimage(si+1,16,0,31,23)
    getimage(si+2,32,0,47,23)
    getimage(si+3,48,0,63,23)
    getimage(si+4,0,24,15,47)
    getimage(si+5,16,24,31,47)
    getimage(si+6,32,24,47,47)
    getimage(si+7,48,24,63,47)

    images(p,0,0)=si
    images(p,1,0)=si+1
    images(p,2,0)=si+2
    images(p,3,0)=si+3
    images(p,0,1)=si+4
    images(p,1,1)=si+5
    images(p,2,1)=si+6
    images(p,3,1)=si+7
    
    people(p,1)=p*60
    people(p,2)=rnd()*25+84
    if p<3 then
        people(p,3)=1
    else
        people(p,3)=0
    end if
    
    if p>0 then
        loadimage("data\" & n & "_1.bmp",si+8)
        image_r(p,0)=si+8
        loadimage("data\" & n & "_2.bmp",si+9)
        image_r(p,1)=si+9
    end if
end sub

makeperson("alex",0,10)

makeperson("woodel",1,20)
phrases(1)="Wood Elf: I have a headache."

makeperson("dwarf",2,30)
phrases(2)="Dwarf Woman: Can you check my throat?"

makeperson("elf",3,40)
phrases(3)="Elf Maiden: Use your magic to heal me."

makeperson("sword",4,50)
phrases(4)="Swordsman: I challenge you to fight!"

makeperson("witch",5,60)
phrases(5)="Witch: Can you repair my dress?"

loadsound("data\music.mp3",1)
loadsound("data\magic.wav",2)

loopsound(1)

do
    pasteimage(5,0,0)
    sync
    if returnkey() then exit do
loop

pcount=4

do
    pasteimage(1,0,0)
    
    for i=1 to pcount
        moveperson(i)
    next i
    
    if rightkey() then
        direction=0
        playerx+=frim*80
        framecounter+=frim*4
        if framecounter>=1 then framecounter=framecounter-int(framecounter)
        if framecounter<0.5 then
            frame=1
        else
            frame=0
        end if
    elseif leftkey() then
        direction=1
        playerx-=frim*80
        framecounter+=frim*4
        if framecounter>=1 then framecounter=framecounter-int(framecounter)
        if framecounter<0.5 then
            frame=1
        else
            frame=0
        end if
    elseif upkey() then
        direction=2
        playery-=frim*80
        framecounter+=frim*4
        if framecounter>=1 then framecounter=framecounter-int(framecounter)
        if framecounter<0.5 then
            frame=1
        else
            frame=0
        end if
    elseif downkey() then
        direction=3
        playery+=frim*80
        framecounter+=frim*4
        if framecounter>=1 then framecounter=framecounter-int(framecounter)
        if framecounter<0.5 then
            frame=1
        else
            frame=0
        end if
    else
        frame=0
        framecounter=0
    end if
    if playery<84 then playery=84
    if playery>176 then playery=176
    if playerx<0 then playerx=0
    if playerx>304 then playerx=304
    pasteimage(images(0,direction,frame),playerx,playery,1)
    
    if spacekey() then
        i=0
        do
            i+=1
            if i>pcount then exit do
            if imagecollision(images(0,0,0),playerx,playery,images(i,0,0),people(i,1),people(i,2)) then
                box(0,149,319,199,rgb(0,0,0))
                line bufPointer,(0,149)-(319,199),rgb(0,0,255),B
                text(1,150,phrases(i))
                sync
                do
                    if spacekey() then
                        if spaceup=1 then spaceup=2
                    else
                        if spaceup=2 then
                            spaceup=0
                            exit do
                        else
                            spaceup=1
                        end if
                    end if
                    if multikey(&h38) and multikey(&h3E) or inkey$()=closeTriggerString then end
                    sleep 1
                loop
                exit do
            end if
        loop
    elseif returnkey() then
        i=0
        do
            i+=1
            if i>pcount then exit do
            if imagecollision(images(0,0,0),playerx,playery,images(i,0,0),people(i,1),people(i,2)) then
                stopsound(1)
                dim as single persx,f=0
                persx=people(i,1)
                do
                    pasteimage(1,0,0)
                    persx+=frim*60
                    f+=frim*4
                    if f>=1 then f=f-int(f)
                    pasteimage(images(i,1,0),persx,109,1)
                    if f<0.5 then
                        pasteimage(images(0,1,0),persx+16,109,1)
                    else
                        pasteimage(images(0,1,1),persx+16,109,1)
                    end if
                    sync
                    if persx>=304 then exit do
                loop
                persx=0
                playsound(2)
                do
                    pasteimage(2,0,0)
                    persx-=60*frim
                    if persx<200-imageheight(image_r(i,0)) then exit do
                    pasteimage(image_r(i,0),0,persx,1)
                    sync
                loop
                persx=0
                do
                    pasteimage(2,0,0)
                    if i=1 or i=3 then
                        if leftkey() then persx+=60*frim
                        if rightkey() then persx-=60*frim
                        if persx>114 then persx=114
                        if persx<-35 then persx=-35
                        pasteimage(image_r(i,0),persx,-240,1)
                        pasteimage(3,200,100,1)
                        pasteimage(image_r(i,1),persx,-240,1)
                    elseif i=2 then
                        if upkey() then persx-=60*frim
                        if downkey() then persx+=60*frim
                        if persx<-72 then
                            if persx<-112 then persx=-112
                            pasteimage(image_r(i,0),0,persx+72,1)
                            pasteimage(4,130,persx+100,1)
                            pasteimage(image_r(i,1),0,persx+72,1)
                        else
                            if persx>100 then persx=100
                            pasteimage(image_r(i,0),0,0,1)
                            pasteimage(4,130,persx+100,1)
                            pasteimage(image_r(i,1),0,0,1)
                        end if
                    elseif i=4 then
                        if upkey() then persx+=60*frim
                        if downkey() then persx-=60*frim
                        if persx>65 then persx=65
                        if persx<-55 then persx=-55
                        pasteimage(image_r(i,0),0,persx-65,1)
                        pasteimage(4,147,100,1)
                        pasteimage(image_r(i,1),0,persx-65,1)
                    elseif i=5 then
                        if upkey() then persx-=60*frim
                        if downkey() then persx+=60*frim
                        if persx>80 then persx=80
                        if persx<0 then persx=0
                        pasteimage(image_r(i,0),0,persx-226,1)
                        pasteimage(4,133,135,1)
                        pasteimage(image_r(i,1),0,persx-226,1)
                    end if
                    sync
                    if spacekey() then
                        spaceup=1
                    elseif spaceup=1 then
                        spaceup=0
                        raped(i)=1
                        if raped(1)=1 and raped(2)=1 and raped(3)=1 and raped(4)=1 then pcount=5
                        exit do
                    end if
                loop
                people(i,1)=304
                people(i,2)=109
                playerx=152
                playery=176
                direction=2
                loopsound(1)
                exit do
            end if
        loop
    end if
    
    sync
loop